package de.fhdw.gaming.memory;


import de.fhdw.gaming.core.domain.Player;
import de.fhdw.gaming.core.domain.Strategy;

/**
 * A Key object that identifies something by a combination of two players and a strategy.
 */
public interface Key {
    
    /**
     * Returns the player "remembering" the outcomes. The strategy saved here belongs to this player.
     */
    public Player<?> getPlayer();
    
    /**
     * Returns the opponent of the active player.
     */
    public Player<?> getOpponent();
    
    /**
     * Returns the strategy of the active player, used against the opponent.
     */
    public Strategy<?, ?, ?> getStrategy();

}
